dofile "script/common_funcs.lua"

function MainFunc(objname, varname, defaultopened)

	local doortotalmovedist = 65
	
	local lockeddoor_obj = lua_sys.Action_Ptr():objectFind(objname)

	if lua_sys.Action_Ptr():getVarInt(varname ) == 0 then
		if defaultopened == "default_open" then
			lua_sys.Action_Ptr():setVarInt(varname,1)
		else
			lua_sys.Action_Ptr():setVarInt(varname,2)
		end
	end	
	
	if lua_sys.Action_Ptr():getVarInt(varname ) == 1 then	--open
		lockeddoor_obj:setRelPos( lockeddoor_obj:getRelPosX(), lockeddoor_obj:getRelPosY() - doortotalmovedist )
	end
	
	
	local movedir = 0
	local moveamount = 0
	
	local msgTable = 
	{
		lua_sys.Action_Ptr(), lua_sys.M_DoorOpen_GetMsgTypeId(), function (msg)
			if msg.name == varname then
				if lua_sys.Action_Ptr():getVarInt(varname ) == 2 then	--closed
					lua_sys.Action_Ptr():playSFX("audio/sfx/environment/door/door_open.wav")
					print ("opening door")
					movedir = -1
				end
			end
		end,
		lua_sys.Action_Ptr(), lua_sys.M_DoorClose_GetMsgTypeId(), function (msg)
			if msg.name == varname then
				if lua_sys.Action_Ptr():getVarInt(varname ) == 1 then	--opened
					lua_sys.Action_Ptr():playSFX("audio/sfx/environment/door/door_close.wav")
					print ("closing door")
					movedir = 1
				end
			end
		end,
		lua_sys.Action_Ptr(), lua_sys.M_GameUpdate_GetMsgTypeId(), function (msg)
		
			if  movedir ~= 0 then
				moveamount = moveamount + 1
				
				if moveamount > doortotalmovedist then
					if movedir < 0 then
						--door is now open
						lua_sys.Action_Ptr():setVarInt(varname,1)
					else
						--door is now closed
						lua_sys.Action_Ptr():setVarInt(varname,2)
					end
					movedir = 0
					moveamount = 0
				end
			
				lockeddoor_obj:setRelPos( lockeddoor_obj:getRelPosX(), lockeddoor_obj:getRelPosY() + movedir )
			end
			
			
			
		end,
	}
	coroutine.yield( msgTable )


end
