dofile "script/common_funcs.lua"

lua_sys.Action_Ptr():scriptRunWithArg3("common_door_handler", "locked_door", "room012_lockeddoor", "default_open" );

lua_sys.Action_Ptr():doorOpen("room012_lockeddoor", true)

if lua_sys.Action_Ptr():getVarInt("room012_beatboss" ) == 0 then

	Common_WaitForTime( 1 )	--hack....make AI get alittle time to at least face you

	--deactivate enemy AI until cutscene happens and finishes
	 lua_sys.Action_Ptr():enemyActivate("mech", false);
	 lua_sys.Action_Ptr():enemyActivate("soldier_shield_enemy", false);
	 lua_sys.Action_Ptr():enemyActivate("soldier_enemy", false);
	

	--wait until walk close to boss
	local msgTable = 
	{
		lua_sys.Action_Ptr(), lua_sys.M_PlayerOnTrigger_GetMsgTypeId(), function (msg)
			if msg.triggerName=="NearBossTrigger" then
				return true
			else
				return false
			end
		end,
	}
	coroutine.yield( msgTable )
	

	--dialog
	
	lua_sys.Action_Ptr():getDialog():addNormal("PORTRAITNAME_SOLDIER","DIALOG_ROOM012_SOLDIER","gfx/hud/soldier_head",lua_sys.Dialog_Side_Right)
	Common_WaitForDialogDone()
	
	--todo: activate soldier and boss
	
	lua_sys.Action_Ptr():doorOpen("room012_lockeddoor", false)
	
	 lua_sys.Action_Ptr():enemyActivate("soldier_shield_enemy", true);
	 lua_sys.Action_Ptr():enemyActivate("soldier_enemy", true);
	
	Common_WaitForTime( 10 )
	
	 lua_sys.Action_Ptr():enemyActivate("mech", true);
	 
	local e1

	e1 = lua_sys.Action_Ptr():enemyFind("mech");
	e2 = lua_sys.Action_Ptr():enemyFind("soldier_shield_enemy");
	e3 = lua_sys.Action_Ptr():enemyFind("soldier_enemy");
	
	--

	print("lua: got enemy"  )

	print(e1 )

	local msgTable = 
	{
		e1, lua_sys.M_CharacterDead_GetMsgTypeId(), function (msg)
			return true
		end,
	}
	coroutine.yield( msgTable )

	print("lua: you beat the boss!!!")

	Common_WaitForTime( 3 )

	lua_sys.Action_Ptr():itemAdd( lua_sys.CollectableItemType_Fuse_Electric, e1:absPosX()-50,  e1:absPosY()
	)
	
	local msgTable = 
	{
		lua_sys.Action_Ptr(), lua_sys.M_TutorialFinish_GetMsgTypeId(), function (msg)
			return true
		end,
	}
	coroutine.yield( msgTable )	

	lua_sys.Action_Ptr():getDialog():addNormal("PORTRAITNAME_ANYA","DIALOG_ROOM012_COMMENT","gfx/hud/anya_head",lua_sys.Dialog_Side_Left)
	Common_WaitForDialogDone()
	
	lua_sys.Action_Ptr():setVarInt("room012_beatboss", 1 );
	
	lua_sys.Action_Ptr():doorOpen("room012_lockeddoor", true)
	
else
	--remove bad guys
	
	local e1
	e1 = lua_sys.Action_Ptr():enemyFind("mech");
	e1 = lua_sys.Action_Ptr():enemyAdd("crowdcontroller", e1:absPosX(), e1:absPosY())
	
	lua_sys.Action_Ptr():objectRemove("mech");
	lua_sys.Action_Ptr():objectRemove("soldier_shield_enemy");
end
